package edu.uci.ics.asterix.aql.expression;

import edu.uci.ics.asterix.aql.base.Statement;
import edu.uci.ics.asterix.aql.expression.visitor.IAqlExpressionVisitor;
import edu.uci.ics.asterix.aql.expression.visitor.IAqlVisitorWithVoidReturn;
import edu.uci.ics.asterix.common.exceptions.AsterixException;

public class TypeDropStatement implements Statement {

    private Identifier typeName;
    private boolean ifExists;

    public TypeDropStatement(Identifier typeName, boolean ifExists) {
        this.typeName = typeName;
        this.ifExists = ifExists;
    }

    @Override
    public Kind getKind() {
        return Kind.TYPE_DROP;
    }

    public Identifier getTypeName() {
        return typeName;
    }

    public boolean getIfExists() {
        return ifExists;
    }

    @Override
    public <R, T> R accept(IAqlExpressionVisitor<R, T> visitor, T arg) throws AsterixException {
        return visitor.visitTypeDropStatement(this, arg);
    }

    @Override
    public <T> void accept(IAqlVisitorWithVoidReturn<T> visitor, T arg) throws AsterixException {
        visitor.visit(this, arg);
    }

}
